<!DOCTYPE html>
{% extends 'en/base.html' %}
{% block content %}
{% include 'en/navbar.html' %}
<div class="container">
	<div class="row">
		<div class="col">
			<h3>
				Evaluation of classifiers for the prediction of  {{feat_pred}} .

			</h3>
			<p>Click in the tabs below to show <strong> results for all classifiers </strong>, the <strong>best classifier</strong> found and 
			individual results for the  <strong>validation set</strong></p>
			<p> You can also <strong>predict the value for a new sample</strong> using the form at the end</p>

			<form action="{{url_for('download_file')}}" method="POST">
				<input type="hidden" name="tmp" value="{{tmpdir}}">
				<input type="hidden" name="filename" value="{{filename}}">
				<input type="hidden" name="modelname" value="{{bestd['name']}}">
				<input type="submit"  class="btn btn-primary mb-3"  id="downButton" value="Download results"></button>
			</form>
			<div class="accordion" id="accordionPanelsStayOpenExample">
				<div class="accordion-item">
					<h4 class="accordion-header" id="panelsStayOpen-headingOne">
						<button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#panelsStayOpen-collapseOne" aria-expanded="true" aria-controls="panelsStayOpen-collapseOne">
							Results for all classifiers
						</button>
					</h4>
					<div id="panelsStayOpen-collapseOne" class="accordion-collapse collapse show" aria-labelledby="panelsStayOpen-headingOne">
						<div class="accordion-body">

							<p> The metric definitions are the following: given the true positives (TP), false positives (FP) and false negatives (FN):
							<ul>
								<li>precision=TP/(TP+FP)</li>
								<li>recall=TP/(TP+FN). Also called sensitivity</li>
								<li> f1 is the harmonic mean of precision and recall
							</ul>
							<p>Scores are computed for each class. The best classifier is:  the one with the highest average f1 score for a multiclass classifier or  with the highest  f1 score por the important class for a binary classifier.
							</p> 

							<p> The class fraction in the dataset are the following:
							<p>
							{% for i in classes %}
							{{i}} ({{ratios[loop.index0]}})
							{% endfor %}
							<p> A classifier should be able to identify correctly at least the existing fraction of each class </p>
							<h2> Results for the training tests for all classifiers </h2>
							<table class='table table-bordered border-primary'>
								<thead>
									<tr><th>Classifier</th><th>Confusion matrix</th><th>Precision</th><th>Recall</th><th>F1-score</th></tr> 
								</thead>
								{% for k,v in d.items() %}
								<tr><td> {{k}}</td>

									<td>{{v['cf_html']|safe}}</td>
									<td>{{v['scores'][0]|safe}}</td>
									<td>{{v['scores'][1]|safe}}</td>
									<td>{{v['scores'][2]|safe}}</td>
									<td><a class="btn btn-secondary mb-3" href="{{url_for('download_model')}}?model={{k}}">Download</a></td>
								</tr>
								{%endfor%}
							</table>

						</div>
					</div>
				</div>
				<div class="accordion-item">
					<h2 class="accordion-header" id="panelsStayOpen-headingTwo">
						<button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#panelsStayOpen-collapseTwo" aria-expanded="false" aria-controls="panelsStayOpen-collapseTwo">
							<strong>Best classifier</strong>. Results for the validation test

						</button>
					</h2>
					<div id="panelsStayOpen-collapseTwo" class="accordion-collapse collapse" aria-labelledby="panelsStayOpen-headingTwo">
						<div class="accordion-body">
							<table class='table table-bordered border-primary'>
								<thead>
									<tr><th>Classifier</th><th>Confusion matrix</th><th>Precision</th><th>Recall</th><th>F1-score</th><th>ROC AUC</th><th>Specificity</th><th>Balanced accuracy</th></tr> 
								</thead>
								<tr><td> {{bestd['name']}}</td>
									<td>{{bestd['cf_html']|safe}}</td>
									<td>{{bestd['scores'][0]|safe}}</td>
									<td>{{bestd['scores'][1]|safe}}</td>
									<td>{{bestd['scores'][2]|safe}}</td>
									<td>{{bestd['scores'][4]|safe}}</td>
									<td> {{admet[0]|safe}}</td>
									<td>{{admet[2]|safe}}</td>
								</tr>

							</table>
						</div>
					</div>
				</div>
				<div class="accordion-item">
					<h2 class="accordion-header" id="panelsStayOpen-headingThree">
						<button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#panelsStayOpen-collapseThree" aria-expanded="false" aria-controls="panelsStayOpen-collapseThree">
							All results for the validation test

						</button>
					</h2>
					<div id="panelsStayOpen-collapseThree" class="accordion-collapse collapse" aria-labelledby="panelsStayOpen-headingThree">
						<div class="accordion-body">
							{{report|safe}}

							{#<p> {{session['mpath']}}</p>#}
						</div>
					</div>
				</div>
			</div>



		</div> {#col#}
	</div>  {#row #}
	<div class="row">
		<div class="col">
			<P> Predict value for a new sample with the best classifier. Select the value of the features: 
			<form name='predict_form' action="javascript:void(0);" method='POST' id="predForm">
				<input type="hidden" name="mpath" value="{{mpath}}">
				<input type="hidden" name="feat_list" value="{{feat_list}}">
				{% for i in selects %}
				<label for="{{i.name}}">{{ i.label | safe }}: </label>
				<select class="form-control" id="{{i.name}}" name="{{i.name}}">
					{% for k,v in i.options.items()  %}
					<option value="{{k}}" id="{{k}}">{{v}}</option>
					{% endfor %}
				</select>   
				{% endfor %}
				<br>
				{% for i in numbers %}
				<label for"{{i.name}}">{{i.label}}:</label>
				<input class="form-control" type="number" step="any" id="{{i.name}}" name="{{i.name}}" min="0"></input>
				{% endfor %}
				{% for i in lists %}
				<label for"{{i.name}}">{{i.label}}:</label>
				<input class="form-control" type="text" id="{{i.name}}" name="{{i.name}}"></input>
				{% endfor %}
				<br>
				<button  class="btn btn-primary mb-3" id="predButton">Send sample</button>
			</form>
			<P id="predResult">
			</P> 

		</div> {#col#}
	</div>  {#row #}
	<div class="row">
		<div class="col">
			<footer class="py-4 bg-light mt-auto">
				<div class="container-fluid">
					<div class="d-flex align-items-center justify-content-between small">
						<div class="text-muted">Copyright &copy; Esteban Egea (UPCT/UM)</div>
						<div>
							<a href="#">Privacy Policy</a>
							&middot;
							<a href="#">Terms &amp; Conditions</a>
						</div>
					</div>
				</div>
			</footer>
		</div> {#col#}
	</div>  {#row #}
</div> {#container #}
<script>
	function showPrediction(d) {
		console.log(d);
		var s=d.slice(0,-1)
		var r=s.split(',')
		var p=document.getElementById('predResult');
		var text='<ul class="list-group">';
		for (var i=0; i<r.length; i++) {
			if (i==0) {
				text+='<li class=\"list-group-item active\">Predicción='+r[i]+'</li>';
			} else {
				text+='<li class=\"list-group-item\">Probabilidad clase '+(i-1)+'='+r[i]+'</li>';
			} 

		}
		text+='</ul>';
		p.innerHTML=text;
	}
function sendForm() {
	console.log("Creating request");
	let f=document.getElementById("predForm");
	let fd=new FormData(f);
	var request = new XMLHttpRequest();
	request.onreadystatechange = function () {
		// In local files, status is 0 upon success in Mozilla Firefox
		if(request.readyState === XMLHttpRequest.DONE) {
			var status = request.status;
			if (status === 0 || (status >= 200 && status < 400)) {
				// The request has been completed successfully
				showPrediction(request.response);
			} else {
				// Oh no! There has been an error with the request!
				console.log("Error in request");
			}
		}
	};
	request.responseType='text'
	request.open("POST", "{{url_for('get_prediction')}}");
	request.send(new FormData(f));
}

//console.log("Entra");
var b=document.getElementById("predButton");
var f=document.getElementById("predForm");
b.onclick=sendForm;
</script>
{% endblock %}

